library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_signed.all;
use ieee.std_logic_arith.all;

use work.dati.all;

entity ALU is
    port (
        a: in w32;
        b: in w32;
        op: in std_logic_vector(2 downto 0);
        ris: out w32;
        zero: out std_logic
        
       );

end ALU;

architecture BEHAVIOR of ALU is

begin

process(a,b,op)
 VARIABLE mris: W32;
 
 

 begin
  
  case op is
  
  -- and
  when "000" =>  mris := a and b;
             
  -- or
  when "001" =>  mris := a or b;
              
  -- add  
  when "010" =>  mris := a + b;
             
                        
  --sub
   when "110" => mris := a-b;
            
  
    -- slt
   when "111" =>  if  a<b then mris := conv_std_logic_vector(1,32);
                      else mris := zero32;
              end if;      
                
    -- xor 
  when "011" =>  mris := a xor b;
      
                          
  -- sll 
  when "100" =>  mris := shl(a,b);
             
   -- srl          
   when "101" => mris := shr(a,b);
             
   when others => mris := zero32;
                  
  end case;
  
  ris <= mris after 3 ns;
  
  if mris = zero32 then 
       zero <= '1';
  else zero <= '0';
end if;
 
 end process;
            

end BEHAVIOR;

