library ieee;
use ieee.std_logic_1164.all;
use work.dati.all;
use ieee.std_logic_unsigned.all;

entity REGISTERFILE is
    port (
      regl1: in std_logic_vector(4 downto 0);
      regl2: in std_logic_vector(4 downto 0);
      regw: in std_logic_vector(4 downto 0);
      datow: in w32;
      RegWrite: in std_logic;
      rst : in std_logic;
      clk : in std_logic;
      datol1: out w32;
      datol2: out w32
        );
end REGISTERFILE;

architecture BEHAVIOR of REGISTERFILE is
signal regfile : vect32(31 downto 0);

begin
datol1<= regfile(conv_integer(regl1));
datol2<= regfile(conv_integer(regl2));

process(regw,RegWrite,clk,rst,datow)
begin
 if rst = '1' then
   for i in 0 to 31 loop
     regfile(i) <= zero32;
   end loop;  
 elsif clk'event and clk='0' and RegWrite='1' then
    regfile(conv_integer(regw))<= datow after 1 ns;
 end if;
end process;   
     
end BEHAVIOR;


