library ieee;
use ieee.std_logic_1164.all;
use work.dati.all;

entity tb_proc is
end tb_proc;

architecture tb of tb_proc is

component CONTROLUNIT is
 port (clk : in std_logic;
       rst : in std_logic;
       opcod : in std_logic_vector(5 downto 0);
       MEMRead,MEMWrite : out std_logic;
       PCWrite,PCWriteCond, IorD, IRWrite, MemtoReg : out std_logic;
       TargetWrite,ALUSelA, RegWrite, RegDest: out std_logic;
       ALUOp: out std_logic_vector(1 downto 0);
       PCSource, ALUSelB : out std_logic_vector(1 downto 0);
       AWrite,BWrite, DataMemWrite,AluOutputWrite: out std_logic ;
       state: out std_logic_vector(3 downto 0)
      );       
end component;


component datapath is
 port (clk : in std_logic;
       rst : in std_logic;
       datain : in w32;
       MemAddr : out w32;
       dataout :out w32;
       opcod : out std_logic_vector(5 downto 0);
       
       PCWrite,PCWriteCond, IorD, IRWrite, MemtoReg : in std_logic;
       TargetWrite,ALUSelA, RegWrite, RegDest: in std_logic;
       AluOpCrtl: in std_logic_vector(1 downto 0);
       PCSource, ALUSelB : in std_logic_vector(1 downto 0);
       AWrite,BWrite, DataMemWrite,AluOutputWrite: in std_logic 
      );
end component;

component MEMORIA is
    port (    
           addr: in w32;
            din: in w32;
             MEMRead: in std_logic;
             MEMWrite: in std_logic;
           dout: out w32
        );

 end component;

signal clk,rst: std_logic;
signal opcod :  std_logic_vector(5 downto 0);
signal MEMRead,MEMWrite :  std_logic;
signal PCWrite,PCWriteCond, IorD, IRWrite, MemtoReg : std_logic;
signal TargetWrite,ALUSelA, RegWrite, RegDest:  std_logic;
signal ALUOp:  std_logic_vector(1 downto 0);
signal PCSource, ALUSelB : std_logic_vector(1 downto 0);
signal AWrite,BWrite, DataMemWrite,AluOutputWrite: std_logic ;
signal state: std_logic_vector(3 downto 0);
signal datain :  w32;
signal MemAddr :  w32;
--signal DataAddr:  w32;
signal dataout : w32;
              
              
 begin
 
 CU: CONTROLUNIT
    port map (clk, rst, opcod, 
       MEMRead,MEMWrite,
       PCWrite,PCWriteCond, IorD, IRWrite, MemtoReg,
       TargetWrite,ALUSelA, RegWrite, RegDest,
       ALUOp, PCSource, ALUSelB,
       AWrite,BWrite, DataMemWrite,AluOutputWrite,
       state );
       
       
 UE: DATAPATH
      port map (clk,rst, 
       datain, MemAddr,  dataout,
       opcod,       
       PCWrite,PCWriteCond, IorD, IRWrite, MemtoReg,
       TargetWrite,ALUSelA, RegWrite, RegDest,
       AluOp,PCSource, ALUSelB,
       AWrite,BWrite, DataMemWrite,AluOutputWrite);
       
 MEM: MEMORIA
        port map (  MemAddr,
            dataout,
             MEMRead,
             MEMWrite,
           datain );
 


 process 
 begin
  clk <= '0';
  wait for 10 ns;
  clk <= '1';
  wait for 10 ns;
 end process;
  
 rst <= '1' after 0 ns, '0' after 10 ns;

end tb;

